Subject: Re: [PATCH/RFC] git-imap-send: use libcurl for implementation

From: Jeff King <[email-masked]>
Date: Sun, 17 Aug 2014 04:30:22 -0400

On Tue, Aug 12, 2014 at 06:59:17PM -0700, Jonathan Nieder wrote:

> > +		curl_socket_t sockfd = tunnel.out; // what about tunnel.in ?
> 
> Hmm.  curl expects to get a socket it can send(), recv(), setsockopt(),
> etc on instead of a pair of fds to read() and write().

I wonder if we could teach run_command to optionally use socketpair()
instead of pipe(). I'm not sure if that would cause problems on Windows,
though.

> I wonder why someone would want to use SSL through a tunnel, though.
> Currently it's impossible to get to the SSL codepath when a tunnel is
> active (it's in the 'else' block an 'if (srvc->tunnel)').  If that
> property is preserved, then we should be safe.

I'm not sure I understand this comment. Even if SSL is not in use,
wouldn't we be passing a regular pipe to curl, which would break?

-Peff